(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["ultimatePagination"] = factory();
	else
		root["ultimatePagination"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.ITEM_KEYS = exports.ITEM_TYPES = undefined;
	exports.getPaginationModel = getPaginationModel;
	
	var _ultimatePaginationConstants = __webpack_require__(1);
	
	Object.defineProperty(exports, 'ITEM_TYPES', {
	  enumerable: true,
	  get: function get() {
	    return _ultimatePaginationConstants.ITEM_TYPES;
	  }
	});
	Object.defineProperty(exports, 'ITEM_KEYS', {
	  enumerable: true,
	  get: function get() {
	    return _ultimatePaginationConstants.ITEM_KEYS;
	  }
	});
	
	var _ultimatePaginationUtils = __webpack_require__(2);
	
	var _ultimatePaginationItemFactories = __webpack_require__(3);
	
	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }
	
	function getPaginationModel(options) {
	  var currentPage = options.currentPage;
	  var totalPages = options.totalPages;
	
	  var paginationModel = [];
	  var createPage = (0, _ultimatePaginationItemFactories.createPageFunctionFactory)(options);
	
	  // Calculate group of central pages
	  var mainPagesStart = Math.max(currentPage - 1, 3) - Math.max(0, currentPage + 3 - totalPages);
	  var mainPagesEnd = Math.min(currentPage + 1, totalPages - 2) + Math.max(0, 4 - currentPage);
	  var mainPages = (0, _ultimatePaginationUtils.createRange)(mainPagesStart, mainPagesEnd).map(createPage);
	
	  paginationModel.push((0, _ultimatePaginationItemFactories.createFirstPageLink)(options));
	  paginationModel.push((0, _ultimatePaginationItemFactories.createPreviousPageLink)(options));
	
	  // Always add the first page
	  paginationModel.push(createPage(1));
	
	  // Show '...' or second page between the last page and main pages group if needed
	  if (mainPagesStart > 3) {
	    paginationModel.push((0, _ultimatePaginationItemFactories.createFirstEllipsis)(mainPagesStart - 1));
	  } else {
	    paginationModel.push(createPage(2));
	  }
	
	  // Add pages +/- from the current page
	  paginationModel.push.apply(paginationModel, _toConsumableArray(mainPages));
	
	  // Show '...' or penult page between main pages group and the last page if needed
	  if (mainPagesEnd < totalPages - 2) {
	    paginationModel.push((0, _ultimatePaginationItemFactories.createSecondEllipsis)(mainPagesEnd + 1));
	  } else {
	    paginationModel.push(createPage(totalPages - 1));
	  }
	
	  // Always add the last page
	  paginationModel.push(createPage(totalPages));
	  paginationModel.push((0, _ultimatePaginationItemFactories.createNextPageLink)(options));
	  paginationModel.push((0, _ultimatePaginationItemFactories.createLastPageLink)(options));
	
	  return paginationModel;
	}

/***/ },
/* 1 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var ITEM_TYPES = exports.ITEM_TYPES = {
	  PAGE: 'PAGE',
	  ELLIPSIS: 'ELLIPSIS',
	  FIRST_PAGE_LINK: 'FIRST_PAGE_LINK',
	  PREVIOS_PAGE_LINK: 'PREVIOS_PAGE_LINK',
	  NEXT_PAGE_LINK: 'NEXT_PAGE_LINK',
	  LAST_PAGE_LINK: 'LAST_PAGE_LINK'
	};
	
	var ITEM_KEYS = exports.ITEM_KEYS = {
	  FIRST_ELLIPSIS: -1,
	  SECOND_ELLISPIS: -2,
	  FIRST_PAGE_LINK: -3,
	  PREVIOS_PAGE_LINK: -4,
	  NEXT_PAGE_LINK: -5,
	  LAST_PAGE_LINK: -6
	};

/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.createRange = createRange;
	function createRange(start, end) {
	  var range = [];
	  for (var i = start; i <= end; i++) {
	    range.push(i);
	  }
	  return range;
	}

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.createPageFunctionFactory = exports.createLastPageLink = exports.createNextPageLink = exports.createPreviousPageLink = exports.createFirstPageLink = exports.createSecondEllipsis = exports.createFirstEllipsis = undefined;
	
	var _ultimatePaginationConstants = __webpack_require__(1);
	
	var createFirstEllipsis = exports.createFirstEllipsis = function createFirstEllipsis(value) {
	  return {
	    type: _ultimatePaginationConstants.ITEM_TYPES.ELLIPSIS,
	    key: _ultimatePaginationConstants.ITEM_KEYS.FIRST_ELLIPSIS,
	    value: value,
	    isActive: false
	  };
	};
	
	var createSecondEllipsis = exports.createSecondEllipsis = function createSecondEllipsis(value) {
	  return {
	    type: _ultimatePaginationConstants.ITEM_TYPES.ELLIPSIS,
	    key: _ultimatePaginationConstants.ITEM_KEYS.SECOND_ELLISPIS,
	    value: value,
	    isActive: false
	  };
	};
	
	var createFirstPageLink = exports.createFirstPageLink = function createFirstPageLink(_ref) {
	  var currentPage = _ref.currentPage;
	
	  return {
	    type: _ultimatePaginationConstants.ITEM_TYPES.FIRST_PAGE_LINK,
	    key: _ultimatePaginationConstants.ITEM_KEYS.FIRST_PAGE_LINK,
	    value: 1,
	    isActive: currentPage === 1
	  };
	};
	
	var createPreviousPageLink = exports.createPreviousPageLink = function createPreviousPageLink(_ref2) {
	  var currentPage = _ref2.currentPage;
	  var totalPages = _ref2.totalPages;
	
	  return {
	    type: _ultimatePaginationConstants.ITEM_TYPES.PREVIOS_PAGE_LINK,
	    key: _ultimatePaginationConstants.ITEM_KEYS.PREVIOS_PAGE_LINK,
	    value: Math.max(1, currentPage - 1),
	    isActive: currentPage === 1
	  };
	};
	
	var createNextPageLink = exports.createNextPageLink = function createNextPageLink(_ref3) {
	  var currentPage = _ref3.currentPage;
	  var totalPages = _ref3.totalPages;
	
	  return {
	    type: _ultimatePaginationConstants.ITEM_TYPES.NEXT_PAGE_LINK,
	    key: _ultimatePaginationConstants.ITEM_KEYS.NEXT_PAGE_LINK,
	    value: Math.min(totalPages, currentPage + 1),
	    isActive: currentPage === totalPages
	  };
	};
	
	var createLastPageLink = exports.createLastPageLink = function createLastPageLink(_ref4) {
	  var currentPage = _ref4.currentPage;
	  var totalPages = _ref4.totalPages;
	
	  return {
	    type: _ultimatePaginationConstants.ITEM_TYPES.LAST_PAGE_LINK,
	    key: _ultimatePaginationConstants.ITEM_KEYS.LAST_PAGE_LINK,
	    value: totalPages,
	    isActive: currentPage === totalPages
	  };
	};
	
	var createPageFunctionFactory = exports.createPageFunctionFactory = function createPageFunctionFactory(_ref5) {
	  var currentPage = _ref5.currentPage;
	
	  return function (pageNumber) {
	    return {
	      type: _ultimatePaginationConstants.ITEM_TYPES.PAGE,
	      key: pageNumber,
	      value: pageNumber,
	      isActive: pageNumber === currentPage
	    };
	  };
	};

/***/ }
/******/ ])
});
;
//# sourceMappingURL=ultimate-pagination.js.map