'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPageFunctionFactory = exports.createLastPageLink = exports.createNextPageLink = exports.createPreviousPageLink = exports.createFirstPageLink = exports.createSecondEllipsis = exports.createFirstEllipsis = undefined;

var _ultimatePaginationConstants = require('./ultimate-pagination-constants');

var createFirstEllipsis = exports.createFirstEllipsis = function createFirstEllipsis(value) {
  return {
    type: _ultimatePaginationConstants.ITEM_TYPES.ELLIPSIS,
    key: _ultimatePaginationConstants.ITEM_KEYS.FIRST_ELLIPSIS,
    value: value,
    isActive: false
  };
};

var createSecondEllipsis = exports.createSecondEllipsis = function createSecondEllipsis(value) {
  return {
    type: _ultimatePaginationConstants.ITEM_TYPES.ELLIPSIS,
    key: _ultimatePaginationConstants.ITEM_KEYS.SECOND_ELLISPIS,
    value: value,
    isActive: false
  };
};

var createFirstPageLink = exports.createFirstPageLink = function createFirstPageLink(_ref) {
  var currentPage = _ref.currentPage;

  return {
    type: _ultimatePaginationConstants.ITEM_TYPES.FIRST_PAGE_LINK,
    key: _ultimatePaginationConstants.ITEM_KEYS.FIRST_PAGE_LINK,
    value: 1,
    isActive: currentPage === 1
  };
};

var createPreviousPageLink = exports.createPreviousPageLink = function createPreviousPageLink(_ref2) {
  var currentPage = _ref2.currentPage;
  var totalPages = _ref2.totalPages;

  return {
    type: _ultimatePaginationConstants.ITEM_TYPES.PREVIOS_PAGE_LINK,
    key: _ultimatePaginationConstants.ITEM_KEYS.PREVIOS_PAGE_LINK,
    value: Math.max(1, currentPage - 1),
    isActive: currentPage === 1
  };
};

var createNextPageLink = exports.createNextPageLink = function createNextPageLink(_ref3) {
  var currentPage = _ref3.currentPage;
  var totalPages = _ref3.totalPages;

  return {
    type: _ultimatePaginationConstants.ITEM_TYPES.NEXT_PAGE_LINK,
    key: _ultimatePaginationConstants.ITEM_KEYS.NEXT_PAGE_LINK,
    value: Math.min(totalPages, currentPage + 1),
    isActive: currentPage === totalPages
  };
};

var createLastPageLink = exports.createLastPageLink = function createLastPageLink(_ref4) {
  var currentPage = _ref4.currentPage;
  var totalPages = _ref4.totalPages;

  return {
    type: _ultimatePaginationConstants.ITEM_TYPES.LAST_PAGE_LINK,
    key: _ultimatePaginationConstants.ITEM_KEYS.LAST_PAGE_LINK,
    value: totalPages,
    isActive: currentPage === totalPages
  };
};

var createPageFunctionFactory = exports.createPageFunctionFactory = function createPageFunctionFactory(_ref5) {
  var currentPage = _ref5.currentPage;

  return function (pageNumber) {
    return {
      type: _ultimatePaginationConstants.ITEM_TYPES.PAGE,
      key: pageNumber,
      value: pageNumber,
      isActive: pageNumber === currentPage
    };
  };
};